<?php

namespace Teknisa\EST\Services;

use Teknisa\Libs\Util\DateUtil;
use Zeedhi\Framework\DataSource\FilterCriteria;
//use Zeedhi\Framework\DataSource\AbstractManager;
//use Manager\AbstractManager;
use Zeedhi\Framework\DataSource\Manager\AbstractManager;

class ESTService {
    
    const SUM = 'SUM';
	const MAX = 'MAX';
	const MIN = 'MIN';
	const COUNT = 'COUNT';
    
    protected $entityManager;
    protected $nameProvider;

    public function __construct($entityManager, $nameProvider, $parameterBag) {
        $this->entityManager     = $entityManager;
        $this->nameProvider      = $nameProvider;
        $this->parameterBag = $parameterBag;
    }
    
    public function getRowsToExpression($rows, $expressions, $filterCriteria,  $dataSourceName, $nrOrg) {
        
        $groupColumnString = '';
        $groupColumnKey    = '';
        $columnsExpression = $expressions["expressions"];
        $groupColumns      = $expressions["groupColumns"];
        $others = array();

        $expressionResul = $this->getResultExpression($filterCriteria, $dataSourceName, $groupColumns, $columnsExpression);
        $result = array();
     
        $this->buildGroupResult($result, $rows, $columnsExpression, $groupColumns);
        foreach ($expressionResul as $item) {
            $item["NRORG"] = $nrOrg;
            $item["totalizerItem"] = true;
            $groupColumnKey = '';
            foreach ($groupColumns as $groupColumn) {
                $register[$groupColumn] = $item[$groupColumn];
                $groupColumnKey .= $item[$groupColumn].'/';
            }
  
            if(isset($result[$groupColumnKey])) {
                $push = false;
                 foreach ($columnsExpression as $column => $expression) {
                    if($expression === self::SUM) {
                        if(isset($result[$groupColumnKey][$column])) {
                            
                            $value = round($item[$column], 6) - round($result[$groupColumnKey][$column], 6);
                        }
                        else {
                            
                            $value = round($item[$column], 6) ;
                        }
                        if($value != 0) {
                            $item[$column] = $value;
                            $push = true;
                        }
                    }
                    else if($expression === self::COUNT) {
                        $value = $item[$column] - $result[$groupColumnKey][$column];
                        if($value != 0) {
                            $item[$column] = $value;
                            $push = true;
                        }
                    }
                    else {
                        if(round($item[$column], 6) != round($result[$groupColumnKey][$column], 6)) {
                            $push = true;
                        }
                    }        
                }
                if($push) $others[] = $item;
            }
            else {
                 $push = false;
                 foreach ($columnsExpression as $column => $expression) {
                    if($expression === self::SUM) {
                        $value = $item[$column];
                        if($value != 0) {
                            $item[$column] = $value;
                            $push = true;
                        }
                    }
                    else if($expression === self::COUNT) {
                        $value = $item[$column];
                        if($value != 0) {
                            $item[$column] = $value;
                            $push = true;
                        }
                    }
                    else {
                        $push = true;
                    }        
                }
                if($push) $others[] = $item;
            }
        }
        
        return $others;
    }
    
    public function buildGroupResult(&$result, $rows, $columnsExpression, $groupColumns) {
        foreach($rows as $row) {
            $groupColumnKey = '';
            foreach ($groupColumns as $groupColumn) {
                if($row[$groupColumn]) {
                    $groupColumnKey .= $row[$groupColumn].'/';
                }
            }
            if(isset($result[$groupColumnKey])) {
                 foreach ($columnsExpression as $column => $expression) {
                    switch ($expression) {
                        case self::SUM:
                            if(isset($result[$groupColumnKey][$column]))
                                $result[$groupColumnKey][$column] += $row[$column];
                            else $result[$groupColumnKey][$column] = $row[$column];
                            break;
                        /*case self::AVG: 
                            $result[$groupColumnKey][$column] = $row[$column] + ( $result[$groupColumnKey][$column] * $count );  
                            $count++;*/
                            
                        case self::COUNT: 
                            $result[$groupColumnKey][$column]++;
                            break;
                        case self::MIN:
                            if($row[$column] < $result[$groupColumnKey][$column]) {
                                $result[$groupColumnKey][$column] = $row[$column];
                            }
                            break;
                        case self::MAX:
                            if($row[$column] > $result[$groupColumnKey][$column]) {
                                $result[$groupColumnKey][$column] = $row[$column];
                            }
                            break;
                        default:
                            // code...
                            break;
                    }
                }
            }
            else {
                 $result[$groupColumnKey] = array();
                 foreach ($columnsExpression as $column => $expression) {
                    if($expression != self::COUNT) {
                        $result[$groupColumnKey][$column] = $row[$column];
                    }
                    else {
                        $result[$groupColumnKey][$column] = 1;
                    }
                }
            }
        }
    }
    
    public function buildGroupResultWithOldOthers(&$result, $rows, $columnsExpression, $groupColumns, $oldOthers) {
        foreach($rows as $row) {
            $groupColumnKey = '';
            foreach ($groupColumns as $groupColumn) {
                $groupColumnKey .= $row[$groupColumn].'/';
            }
            if(isset($result[$groupColumnKey])) {
                 foreach ($columnsExpression as $column => $expression) {
                    switch ($expression) {
                        case self::SUM:
                            $result[$groupColumnKey][$column] -= $row[$column];
                            break;
                        /*case self::AVG: 
                            $result[$groupColumnKey][$column] = $row[$column] + ( $result[$groupColumnKey][$column] * $count );  
                            $count++;*/
                            
                        case self::COUNT: 
                            $result[$groupColumnKey][$column]++;
                            break;
                        case self::MIN:
                            if($row[$column] < $result[$groupColumnKey][$column]) {
                                $result[$groupColumnKey][$column] = $row[$column];
                            }
                            break;
                        case self::MAX:
                            if($row[$column] > $result[$groupColumnKey][$column]) {
                                $result[$groupColumnKey][$column] = $row[$column];
                            }
                            break;
                        default:
                            // code...
                            break;
                    }
                }
            }
        }
    }
        
    public function calculateOthersByOldResults($rows, $expressions, $filterCriteria, $dataSourceName, $oldOthers, $nrOrg) {
        
        $result     = array();
        
        $others     = array();
        $oldResult  = array();
        $others     = array();
        
        $columnsExpression = $expressions["expressions"];
        
        $groupColumns = $expressions["groupColumns"];


        $expressionResul = $this->getResultExpression($filterCriteria, $dataSourceName, $groupColumns, $columnsExpression);

        $result = array();
        $this->buildGroupResult($result, $rows, $columnsExpression, $groupColumns);
        $this->buildGroupResult($oldResult, $oldOthers, $columnsExpression, $groupColumns);

        //$others["others"]          = $oldResult["others"];

        $oldResult = array_merge($result, $oldResult);
        $this->getOthers($oldOthersResult, $oldOthers, $result, $columnsExpression, $groupColumns);

        $this->getOthers($others, $expressionResul, $oldResult, $columnsExpression, $groupColumns);
        
        $teste = array();
        $testeResul = array();
        
        //$this->getOthers($others, $expressionResul, $result, $columnsExpression, $groupColumns);
        // var_dump($oldOthersResult);die;
        $others = array_merge($oldOthersResult, $others);
        //var_dump($others);die;
        
        return $others;
        
    }    
        
    public function getDataSource($dataSourceName = '') {
        return $this->nameProvider->getDataSourceByName($dataSourceName);
    }
    
    public function getParams($parameterBagColumns, $filterCriteria) {
        $conditions = array();
        $params     = array();
        
        foreach ($filterCriteria->getConditions() as $condition) {
            $conditions[$condition["columnName"]] = $condition["value"];
        }
        
        foreach ($parameterBagColumns as $column) {
            if(isset($conditions[$column])) {
                $params[$column] = $conditions[$column];
            }
            else {
                $params[$column] = '';
            }
        }
        return $params;
    }

    /**
     * @param FilterCriteria $filterCriteria
     * @param $query
     * @return array
     */
    public function buildParamBag($filterCriteria, $query) {
        $parameterBagColumns = array();
        $query = strtoupper($query);

        foreach ($filterCriteria->getConditions() as $condition) {
            $columnName = strtoupper($condition['columnName']);

            if (strpos($query, ':'.$columnName)) {
                $parameterBagColumns[] = $columnName;
            }
        }

        return $parameterBagColumns;
    }
    
    protected function getOthers(&$others, $params, $result, $columnsExpression, $groupColumns) {

        foreach ($params as $item) {
            $item["other"] = true; 
            $groupColumnKey = '';
            
            foreach ($groupColumns as $groupColumn) {
                $register[$groupColumn]  = $item[$groupColumn];
                $groupColumnKey         .= $item[$groupColumn].'/';
            
            }
            if(isset($result[$groupColumnKey])) {
                $push = false;

                foreach ($columnsExpression as $column => $expression) {
                    if($expression === self::SUM) {
                        $value = round($item[$column], 6) - round($result[$groupColumnKey][$column], 6);
                        if($value != 0) {
                            $item[$column] = $value;
                            $push = true;
                        }
                    }
                    else if($expression === self::COUNT) {
                        $value = $item[$column] - $result[$groupColumnKey][$column];
                        if($value != 0) {
                            $item[$column] = $value;
                            $push = true;
                        }
                    }
                    else {
                        if(round($item[$column], 6) != round($result[$groupColumnKey][$column], 6)) {
                            $push = true;
                        }
                    }        
                }
                if($push) {
                    $item["totalizerItem"] = true;
                    $others[] = $item;
                }
            }
            else {
                foreach ($columnsExpression as $column => $expression) {
                    if($expression === self::SUM) {
                        $value = $item[$column];
                        if($value != 0) {
                            $item[$column] = $value;
                            $push = true;
                        }
                    }
                    else if($expression === self::COUNT) {
                        $value = $item[$column];
                        if($value != 0) {
                            $item[$column] = $value;
                            $push = true;
                        }
                    }
                    else {
                        $push = true;
                    }        
                }
                if($push) {
                    $item["totalizerItem"] = true;
                    $others[] = $item;
                }
            }
        }
    }
    
    protected function getResultExpression($filterCriteria, $dataSourceName, $groupColumns, $columnsExpression) {
        $groupColumnString = $this->getGroupColumnsString($groupColumns);
        $columnExpressionString = $this->getColmnsExpressionString($columnsExpression);
        
        $dataSource = $this->getDataSource($dataSourceName);

        $query = $dataSource->getQuery();
        $parameterBagColumns = $this->buildParamBag($filterCriteria,  $query);
        $params = $this->getParams($parameterBagColumns, $filterCriteria);
        $extraFilters = $this->populateParameterBag($filterCriteria, $parameterBagColumns);
        return $this->getQueryExpression($query, $params, $columnExpressionString, $groupColumnString, $extraFilters);
    }
    
    protected function getGroupColumnsString($groupColumns) {
                
        $groupColumnString = '';
                
        foreach ($groupColumns as $groupColumn) {
            $groupColumnString.= $groupColumn.',';
            $others["others"][$groupColumn] = '';
        }
        
        $groupColumnString = substr($groupColumnString, 0, strlen($groupColumnString) - 1) . ' ';
        return $groupColumnString;
    }
    
    protected function getColmnsExpressionString($columnsExpression) {
                
        $columnExpressionString = '';
        
        foreach ($columnsExpression as $column => $expression) {
            $columnExpressionString.= $expression . '(' . $column . ') AS ' . "$column,";
        }
        
        $columnExpressionString = substr($columnExpressionString, 0, strlen($columnExpressionString) - 1) . '';
        return $columnExpressionString;
    }
    
    public function populateParameterBag(FilterCriteria $filterCriteria, $parameterBagColumns) {
        $conditions = array();

        foreach ($filterCriteria->getConditions() as $condition) {
            $columnName = $condition['columnName'];
            if (in_array($columnName, $parameterBagColumns)) {
                $this->parameterBag->set($columnName, $this->processConditionValue($condition));
            } else {
                $conditions[] = $condition;
            }
        }

        $newFilterCriteria = new FilterCriteria(
            $filterCriteria->getDataSourceName(),
            $conditions,
            $filterCriteria->getPage(),
            $filterCriteria->getPageSize()
        );

        return $newFilterCriteria;
    }
    
    protected function processConditionValue($condition) {
        return $condition['value'];
    }
    
    protected function processWhereClause(FilterCriteria $filterCriteria, QueryBuilder $query) {
        $params = $this->buildQueryConditions($filterCriteria, $query);
        if ($filterCriteria->hasWhereClause()) {
            $query->andWhere($filterCriteria->getWhereClause());
            foreach ($filterCriteria->getWhereClauseParams() as $bindColumnName => $value) {
                $bindColumnName = ltrim($bindColumnName, ':');
                $params[$bindColumnName] = $value;
            }
        }

        foreach ($this->dataSourceConfig->getConditions() as $condition) {
            $query->andWhere($condition);
        }

        $params = $this->completeParamsWithParameterBag($query, $params);
        return $params;
    }
    
    public function processExtraConditions($condArray){
        $where = '';
        if(count($condArray) > 0){
            $where .= 'WHERE ';
            $count = 0;
            foreach($condArray as $cond){
                $concat = '';
                switch ($cond['operator']) {
                    case 'BETWEEN':
                        if($count > 0)
                            $concat.= ' AND ';    
                        $concat .= ' '.$cond['columnName'].' BETWEEN '."'".$cond['value'][0]."'".' AND '."'".$cond['value'][1]."'".' ';
                        $count++;
                        break;
                    case '=':
                        if($count > 0)
                            $concat.= ' AND ';
                        $concat .= ' '.$cond['columnName'].' = '."'".$cond['value']."'".' ';
                        $count++;
                        break;
                    case 'IN':
                        if($count > 0)
                            $concat.= ' AND ';
                            
                        $lista = '';
                        $cntLista = 0;
                        if(!is_array($cond['value']))
                            $cond['value'] = [$cond['value']];
                        foreach($cond['value'] as $value){
                            if($cntLista > 0)
                                $lista.= ',';
                            $lista .= "'".$value."'";
                            $cntLista++;
                        }
                        $concat .= ' '.$cond['columnName'].' IN ('.$lista.') ';
                        $count++;
                        break;
                }
                $where .= $concat;
            }
        }
        return $where;
    }
    
    public function getQueryExpression($query, $params, $columnExpression, $groupColumns, $extraFilterCriteria) {
      $extraFilter = $extraFilterCriteria->getConditions();
      $where = $this->processExtraConditions($extraFilter);
      $sql = "SELECT $columnExpression, $groupColumns FROM ( $query ) $where GROUP BY $groupColumns ORDER BY $groupColumns";
      
      $connection = $this->entityManager->getConnection();

      $query = $connection->prepare($sql);
      $query->execute($params);
      return $query->fetchAll();
    }

}