/*+
|                                               |
|     Trigger: DTULTATU_ITEMDWOPER              |  
|     Tabela : ITEMDWOPER                       |
|                                               |
|     Criao:                                  |
|     06/09/2007 - Luiz Passos                  |
|                                               |
+*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ITEMDWOPER'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_ITEMDWOPER
GO

CREATE TRIGGER DTULTATU_ITEMDWOPER
ON ITEMDWOPER 
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
         (SELECT 'ITEMDWOPER', 'CDTABELADW='  + CDTABELADW +
                               ';CDITEMDW='   + CDITEMDW   +
                               ';CDOPERADOR=' + CDOPERADOR + ';', GETDATE() FROM DELETED)

   END
   ELSE BEGIN
      UPDATE ITEMDWOPER
      SET DTULTATUITDWOP = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(ITEMDWOPER.CDTABELADW, 0) = ISNULL(INSERTED.CDTABELADW, 0)) AND
            (ISNULL(ITEMDWOPER.CDITEMDW, 0)   = ISNULL(INSERTED.CDITEMDW, 0))   AND
            (ISNULL(ITEMDWOPER.CDOPERADOR, 0) = ISNULL(INSERTED.CDOPERADOR, 0));
   END;
END;
GO 

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_ITEMDWOPER','4.11.176';
GO

