package com.javaseleniumtemplate.pages.EstoquePages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class RequisicaoDeEstoquePage extends PageBase {


    ///Mapoping
    //Evento de loading da pagina:
    By loadingWait = By.xpath("//*[@class='zh-loading-desc ng-binding']");
    //BUSCA DO PRODUTO ATRAVES DO FLOAT-CONTROL:

    By campoProcurarFloatControl = By.xpath("//*[@id='popup']//*[@placeholder='Procurar']");
//Aplicar Filtro
    By clear = By.xpath("//*[@data-zh-id='1532905187257505597546_filter_action_clear']");
    By iconeUnidade = By.xpath("//*[@data-zh-id='1532905187676976214586']//*[@id='NMFILIAL']/span[1]");
    By unidade = By.xpath("//span[text()='HELA INGREDIENTES BRASIL']");
    By iconeData = By.xpath("//*[@data-zh-id='15329051873432479889612']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
    By dataEscolhida = By.xpath("//*[@id='zh-calendar-Calendar']//*[.='1']");
    By iconeDataEscolhidaPrevista = By.xpath("//*[@data-zh-id='15329051873711188136614']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");

    By btnOkFiltro = By.xpath("//*[@id='footer']/div[3]/ul/li/a/span");
    By btnAplicarFilro = By.xpath("//span[text()='Aplicar filtro']");


    // EfetuarRequisicaodeEstoque
    By btnAdicionar = By.xpath("//*[@data-zh-id='15329051874017583542620']");
    By descricao = By.id("DSREQUESTO");

    By setor = By.xpath("//*[@data-zh-id='153290518743418761617']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By setorEscolhido = By.xpath("//span[text()='Administrativo']");

    //Almoxarifado
    By almoxarifadoOrigem = By.xpath("//*[@data-zh-id='1532905187902399559590']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By almoxarifadoDestino = By.xpath("//*[@data-zh-id='15329051871692653411600']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By selectAlmoxarifadoOrigem = By.xpath("//span[text()='HELA MATRIZ']");

    By selectAlmoxarifadoDestino = By.xpath("//span[text()='HELA LOJA']");

    By salvar = By.xpath("//span[text()='Salvar']");


    //Produto

    By btnOk = By.xpath("//span[text()='OK']");

    By btnAdicionarProduto = By.xpath("//*[@data-zh-id='1532905187358523157575']");

    By produto = By.xpath("//*[@data-zh-id='1532905187513891082559']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By selectProduto = By.xpath("//span[text()='SUMO DE LIMAO - CX12 500ML']");
    By quantidadeRequisitada = By.id("QTREQUESTO");


    //Banco
    By numeroLancado = By.cssSelector(".row-editing > .td:nth-child(1) > span");

   //Editar
    By editar = By.xpath("//*[@data-zh-id='15329051874017583542620']");

   // Excluir
    By itemDeletado = By.xpath("//span[text()='Deletar']");
    By excluir = By.xpath("//*[@data-zh-id='1532905187134785494624']");
    By btnAlerta = By.xpath("//span[text()='Sim']");


    public void preencherFiltroRequisicaoDeEstoque(String descUnidade){

        click(clear);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(iconeUnidade);
        click(iconeUnidade);

        //unidade
        //Start Float-control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,descUnidade);
        click(unidade);
        waitForInvisibilityOfElementLocated(loadingWait);
        //End Search Float Control


        //Data Requisição
        waitForVisibilityOfElementLocated(iconeData);
        click(iconeData);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(dataEscolhida);
        click(dataEscolhida);
        waitForVisibilityOfElementLocated(btnOkFiltro);
        click(btnOkFiltro);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Data Prevista
        waitForVisibilityOfElementLocated(iconeDataEscolhidaPrevista);
        click(iconeDataEscolhidaPrevista);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(dataEscolhida);
        click(dataEscolhida);
        waitForVisibilityOfElementLocated(btnOkFiltro);
        click(btnOkFiltro);
        waitForInvisibilityOfElementLocated(loadingWait);

        click(btnAplicarFilro);
        waitForInvisibilityOfElementLocated(loadingWait);


    }
    public void EfetuarRequisicaodeEstoque(String campoDescricao,String campoSetor, String campoAlmoxarifadoOrigem, String campoAlmoxarifadoDestino,String campoProduto,String campoQuantidadeRequisitada) {
        click(btnAdicionar);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Descrição
        waitForVisibilityOfElementLocated(descricao);
        sendKeys(descricao, campoDescricao);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Setor
        waitForVisibilityOfElementLocated(setor);
        click(setor);
        waitForVisibilityOfElementLocated(loadingWait);

        //Start Float Control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,campoSetor);
        waitForInvisibilityOfElementLocated(loadingWait);
        click(setorEscolhido);
        waitForInvisibilityOfElementLocated(loadingWait);
        //End Search Float Control

        //almoxarifado
        waitForVisibilityOfElementLocated(almoxarifadoOrigem);
        click(almoxarifadoOrigem);

        //Start Float-control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl, campoAlmoxarifadoOrigem);
        click(selectAlmoxarifadoOrigem);
        waitForInvisibilityOfElementLocated(loadingWait);
        //end search  float-control

        waitForVisibilityOfElementLocated(almoxarifadoDestino);
        click(almoxarifadoDestino);

        //Start Float-control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl, campoAlmoxarifadoDestino);
        click(selectAlmoxarifadoDestino);
        waitForInvisibilityOfElementLocated(loadingWait);
        //end search  float-control

        //Salvar
        waitForVisibilityOfElementLocated(salvar);
        click(salvar);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Produtos

        //poup up
        waitForVisibilityOfElementLocated(btnOk);
        click(btnOk);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Adicionar produto
        waitForVisibilityOfElementLocated(btnAdicionarProduto);
        click(btnAdicionarProduto);
        waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(produto);
        click(produto);
        waitForInvisibilityOfElementLocated(loadingWait);

        //start float-control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl, campoProduto);
        click(selectProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
        //end search  float-control


        waitForVisibilityOfElementLocated(quantidadeRequisitada);
        sendKeys(quantidadeRequisitada, campoQuantidadeRequisitada);
        waitForInvisibilityOfElementLocated(loadingWait);


        waitForVisibilityOfElementLocated(salvar);
        click(salvar);
        waitForInvisibilityOfElementLocated(loadingWait);


        //Banco captura

        waitForVisibilityOfElementLocated(numeroLancado);
        click(numeroLancado);


    }

    public String retornaQuantidadeRequisitadaItem(){
    return getText(numeroLancado);


    }

    public void EditarRequisicaoEstoque(String campoEditado){
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(editar);
        click(editar);
        waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(descricao);
       clearAndSendKeys(descricao,campoEditado);
       waitForInvisibilityOfElementLocated(loadingWait);

       waitForVisibilityOfElementLocated(salvar);
       click(salvar);
       waitForInvisibilityOfElementLocated(loadingWait);

    }

    public void ExcluirRequisicaoDeEstoque(){

        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(itemDeletado);
        click(itemDeletado);
        waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(excluir);
       click(excluir);
       waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(btnAlerta);
        click(btnAlerta);
       waitForInvisibilityOfElementLocated(loadingWait);
        

    }
}
