package com.javaseleniumtemplate.tests.Estoque;


import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.dbsteps.DBSteps;
import com.javaseleniumtemplate.flows.EntradaDeEstoqueFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.EstoquePages.EntradaDeEstoquePage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.Assert;
import org.testng.annotations.Ignore;
import org.testng.annotations.Test;

public class EntradaDeEstoqueTests extends TestBase{
    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    EntradaDeEstoqueFlows entradaDeEstoqueFlows;
    EntradaDeEstoquePage entradaDeEstoquePage;


    @Test(description = "Est-03")
    public void EfetuarEntradaDeEstoque(){

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        entradaDeEstoqueFlows = new EntradaDeEstoqueFlows();
        entradaDeEstoquePage = new EntradaDeEstoquePage();

        //Parameteres_login:

        //Parameteres_Lançamento:
        String quantidade = "3";
        String cmpDesc = "Teste Automatizado";
        String descProduto = "SUMO DE LIMAO - CX12 500ML";
        String descAlmoxarifado = "HELA MATRIZ";
        String DescCampoLote = "025/50";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String valorUnitario = "1,2";
        String valorEstoqueEsperado = "18";
        String valorTotalEstoqueEsperado = "18";






        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoEntradaDeEstoque();
        entradaDeEstoqueFlows.aplicarFiltro(descUnidade,descAlmoxarifado);
        entradaDeEstoqueFlows.AdicionarEntradaEstoque(cmpDesc,descProduto,quantidade,descAlmoxarifado,DescCampoLote,valorUnitario);

        //Banco
      String numeroLancamento = entradaDeEstoquePage.retornaNumeroLacamento();

      Assert.assertTrue(DBSteps.retornaQuatidadeEstoque( numeroLancamento).contains(valorEstoqueEsperado));


       String valorLancamentoTotalEstoque = entradaDeEstoquePage.retornaNumeroLacamentoTotal();
      Assert.assertTrue(DBSteps.retornaValorTotalQuantidadeEstoque(valorLancamentoTotalEstoque).contains(valorTotalEstoqueEsperado));
       Assert.assertEquals(numeroLancamento, valorLancamentoTotalEstoque);







    }

    @Test(description = "Est-25")
    public void EditarEntradaEstoque(){
        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        entradaDeEstoqueFlows = new EntradaDeEstoqueFlows();
        entradaDeEstoquePage = new EntradaDeEstoquePage();


        //Parameteres_Editar

        String cmpDesc2 = "Deletar";


        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoEntradaDeEstoque();
        //entradaDeEstoqueFlows.aplicarFiltro(descUnidade,descAlmoxarifado);
       entradaDeEstoqueFlows.EditarEntradaEstoque(cmpDesc2);

    }
    @Test(description = "Est-26")
    public void ExcluirEntradaDeEstoque(){
        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        entradaDeEstoqueFlows = new EntradaDeEstoqueFlows();
        entradaDeEstoquePage = new EntradaDeEstoquePage();



        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoEntradaDeEstoque();

        entradaDeEstoqueFlows.ExcluirEntradaDeEstoque();
    }


    @Test ( description = "Est-00")
    @Ignore
    public void TesteBanco() {

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        entradaDeEstoqueFlows = new EntradaDeEstoqueFlows();
        entradaDeEstoquePage = new EntradaDeEstoquePage();






        //Rotinas:
       // loginFlows.efetuarLogin();
        String ntlancestq = "0000006893";
       String teste =  DBSteps.retornaValorTotalQuantidadeEstoque(ntlancestq);
        System.out.println(teste);

    }

}







