package com.javaseleniumtemplate.tests.Estoque;
import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.ImplantacaoEstoqueFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.EstoquePages.ImplantacaoEstoquePage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.annotations.Test;

public class ImplantacaoDeEstoqueTests extends TestBase {
    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    ImplantacaoEstoqueFlows implantacaoEstoqueFlows;
    ImplantacaoEstoquePage implantacaoEstoquePage;


    @Test (description = "Est-08")
    public void efetuarImplantacaoEstoque(){

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        implantacaoEstoqueFlows = new ImplantacaoEstoqueFlows();
        implantacaoEstoquePage = new ImplantacaoEstoquePage();

        //Parameteres
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descAlmoxarifado = "HELA MATRIZ";
        String quantidade = "1";
        String cmpDesc = "Teste Automatizado";
        String descProduto = "Hela Poultry Broth Paste Clear KG";
        String DescCampoLote = "T08/2023";


        loginFlows.efetuarLogin();
        mainFlows.AcessandoImplantacaoEstoque();
        implantacaoEstoqueFlows.aplicarFiltro(descUnidade,descAlmoxarifado);
        implantacaoEstoqueFlows.AdicionarImplantacaoEstoque(quantidade,cmpDesc,descProduto,descAlmoxarifado,DescCampoLote);

    }
    @Test(description = "Est-09")
    public void editarImplantacaoEstoque(){

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        implantacaoEstoqueFlows = new ImplantacaoEstoqueFlows();
        implantacaoEstoquePage = new ImplantacaoEstoquePage();

        //Parameteres
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descAlmoxarifado = "HELA MATRIZ";
        String DescCampoLote = "T08/2023";
        //Parameteres_Editar
        String quantidadeEdit = "1,75";
        String descProduto2 = "Geflugelbruhe Paste (Hela 7562510050001)";
        String cmpDesc2 = "Deletar";

        loginFlows.efetuarLogin();
        mainFlows.AcessandoImplantacaoEstoque();
        implantacaoEstoqueFlows.aplicarFiltro(descUnidade,descAlmoxarifado);
        implantacaoEstoqueFlows.EditarImplantacaoEstoque(cmpDesc2,quantidadeEdit,descProduto2,descAlmoxarifado,DescCampoLote);

    }
    @Test(description = "Est-10")
    public void excluirImplantacaoEstoque(){

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        implantacaoEstoqueFlows = new ImplantacaoEstoqueFlows();
        implantacaoEstoquePage = new ImplantacaoEstoquePage();

        //Parameteres
        String usuario = "deivison.andrade@teknisa.com";
        String senha = "1";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descAlmoxarifado = "HELA MATRIZ";

        loginFlows.efetuarLogin();
        mainFlows.AcessandoImplantacaoEstoque();
        implantacaoEstoqueFlows.aplicarFiltro(descUnidade,descAlmoxarifado);
        implantacaoEstoqueFlows.ExcluirImplantacaoEstoque();

    }
    @Test(description = "Est-11")
    public void importarImplantacaoDeEstoque(){

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        implantacaoEstoqueFlows = new ImplantacaoEstoqueFlows();
        implantacaoEstoquePage = new ImplantacaoEstoquePage();

        //Parameteres

        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descAlmoxarifado = "HELA MATRIZ";


        loginFlows.efetuarLogin();
        mainFlows.AcessandoImplantacaoEstoque();
        implantacaoEstoqueFlows.aplicarFiltro(descUnidade,descAlmoxarifado);
        implantacaoEstoqueFlows.ImportarImplantacaoDeEstoque();

    }


}
